package Session; #singleton

use sCode;
my %Session={PASSWD=>undef, DB=>undef, VIR=>0};

sub init {
        my ($self, $session_passwd)=@_;
        $self->{PASSWD}=$session_passwd;
        $self->{DB}=undef;
}

sub populate {
       my ($self, $encoded_string, $session_passwd)=@_;
       if(!$self->{PASSWD}){return undef}
       my $lsession_passwd=$self->{PASSWD};
       if($lsession_passwd ne $session_passwd){return undef}
       my $hash=sCode->decode($encoded_string);
       $self->{DB}=$hash;
}

sub add {
       my ($self, $key, $val, $magic)=@_;
       if(!($self->{PASSWD}||($magic=~/^t/))){return undef}
       if($magic !~ /^[ret]/){return undef}
       if(exists $self->{DB}->{$key}){
               my $lpass=$self->{DB}->{$key}->[0];
               if($lpass ne $magic){
                       return undef;
               }
       }
       $self->{DB}->{$key}=[$magic,$val];
       $self->{VIR}++;
}

sub delete {
       my ($self, $key,  $magic)=@_;
       if(!($self->{PASSWD}||($magic=~/^t/))){return undef}
       if($magic !~ /^[et]/){return undef}
       if(exists $self->{DB}->{$key}){
               my $lmagic=$self->{DB}->{$key}->[0];
               if($lmagic ne $magic){
                       return undef;
               }
               delete $self->{DB}->{$key};
               $self->{VIR}--;
       }
}

sub query {
        my ($self, $key, $magic)=@_;
        if(!($self->{PASSWD}||($magic=~/^t/))){return undef}
        my ($lmagic, $val)=@{$self->{DB}->{$key}};
        if($lmagic =~ /^[rs]/){
                return $val
        }
        if($lmagic eq $magic){
                return $val
        }
        return undef;
}

sub dump {
       my ($self, $session_passwd)=@_;        
       my $lsession_passwd=$self->{PASSWD};        
       if($lsession_passwd ne $session_passwd){
               return undef
       }
       my $h={};
       my $magic="";
       my $db=$self->{DB};
       for my $k (keys %$db){
               $magic=$db->{$k}->[0];
               if($magic=~/^[res]/){
                       $h->{$k}=$db->{$k};                       
               }
       }
       my $enc_hash=sCode->encode($h,2);
       return $enc_hash;
}        

sub destroy {
        my ($self, $session_passwd)=@_;
        my $lsession_passwd=$self->{PASSWD};
        if($lsession_passwd eq $session_passwd){
                $self->{PASSWD}=undef;
                $self->{DB}=undef;
                return 1
        }
        return 0
}
