package UI; # singleton

my $DEBUG=0;
use Tk;
use Tk::Balloon;

%UI=();

sub new {
	my $self=shift;
	my $top = MainWindow->new(-width=>240, -height=>320);
	   $top->resizable(0, 0);
	my $head=$top->Frame(-width=>240, -height=>20)->pack();	
	my $header=$head->Label(-text=>"imli", -width=>20,-justify=>'left');
           $header->pack();
        #   $header->place(-relx=>0,-rely=>0);
	#my $pageno=$head->Label(-text=>"1 of 10", -width=>10,-justify=>'right');
        #   $pageno->place(-relx=>0.66,-rely=>0);	   
	my $middle=$top->Frame(-width=>240, -height=>260)->pack();
	my $footer =$top->Frame(-width => 240,-height=> 40)->pack();
	my $imgl=$footer->Bitmap('imgl',-file=>"images/left");
	my $imgr=$footer->Bitmap('imgr',-file=>"images/right");
#	my $imgu=$footer->Bitmap('imgu',-file=>"images/up");
#	my $imgd=$footer->Bitmap('imgd',-file=>"images/down");
	my $imge=$footer->Bitmap('imge',-file=>"images/reload");
	my $imgs=$footer->Bitmap('imgs',-file=>"images/stop");
        my $imgau=$footer->Bitmap('imgau',-file=>"images/audio");
	
        
        my $headpress=sub{_play_title()};
        $header->Tk::bind("<1>", $headpress);
        
	my $bl=$footer->Button(-image=>'imgl',
	                       -highlightthickness=>0,
			       -command=>sub {_buttons("left")});
			       
	my $br=$footer->Button(-image=>'imgr',
	                       -highlightthickness=>0,
			       -command=>sub {_buttons("right")});
			       
#	my $bu=$footer->Button(-image=>'imgu',
#	                       -highlightthickness=>0,
#			       -command=>sub {_buttons("up")});
#			       
#	my $bd=$footer->Button(-image=>'imgd',
#	                       -highlightthickness=>0,
#			       -command=>sub {_buttons("down")});
			       
	my $be=$footer->Button(-image=>'imge',
	                       -highlightthickness=>0,
			       -command=>sub {_buttons("reload")});
			       
	my $bs=$footer->Button(-image=>'imgs',
	                       -highlightthickness=>0,
			       -command=>sub {_buttons("stop")});

	my $ba=$footer->Button(-image=>'imgau',
	                       -highlightthickness=>0,
			       -command=>sub {_buttons("audio")});

#	$bl->place(-relx=>0, -rely=>0, -relwidth=>0.166, -relheight=>1);
#	$br->place(-relx=>0.166, -rely=>0, -relwidth=>0.166, -relheight=>1);
#	$bs->place(-relx=>0.332, -rely=>0,
#		   -relwidth=>0.166, -relheight=>1);
#	$be->place(-relx=>0.5, -rely=>0,
#		   -relwidth=>0.166, -relheight=>1);
#	$bu->place(-relx=>0.666, -rely=>0,
#		   -relwidth=>0.166, -relheight=>1);		   
#	$bd->place(-relx=>0.833, -rely=>0,
#		   -relwidth=>0.166, -relheight=>1);

	$bl->place(-relx=>0, -rely=>0, -relwidth=>0.2, -relheight=>1);
	$br->place(-relx=>0.2, -rely=>0, -relwidth=>0.2, -relheight=>1);
	$bs->place(-relx=>0.4, -rely=>0,
		   -relwidth=>0.2, -relheight=>1);
	$be->place(-relx=>0.6, -rely=>0,
		   -relwidth=>0.2, -relheight=>1);
	$ba->place(-relx=>0.8, -rely=>0,
		   -relwidth=>0.2, -relheight=>1);		   


	my $balloon=$top->Balloon(-background=>'white');		   
	%$self=(top=>$top,
                header=>$header,
                middle=>$middle,
                footer=>$footer,
                balloon=>$balloon,
                left=>$bl, right=>$br, 
                stop=>$bs, reload=>$be,
                audio=>$ba,
                audiostate=>0,                
                button_state=>{left=>1, right=>1, 
                           stop=>0, reload=>1,
                           audio=>1
                         }
                );
}


sub main_window {
	my $self=shift;
	return $self->{top};
}

sub header {
	my $self=shift;
	return $self->{header};
}


sub display {
	my $self=shift;
	return $self->{middle};
}

sub footer {
	my $self=shift;
	return $self->{footer};
}

sub balloon {
	my $self=shift;
	return $self->{balloon};
}

sub button {
        my $self=shift;
        _buttons(@_);                
}        




sub toggleaudio {
        my $self=shift;
        if(UI->{audiostate}){
                UI->{audiostate}=0;
                UI->activebuttons({left=>1, right=>1, 
                           stop=>0, reload=>1,
                           audio=>1
                           });
        }else{
                UI->{audiostate}=1;
                UI->activebuttons({left=>0, right=>0, 
                           stop=>0, reload=>0,
                           audio=>2
                         });
       }                  
}        


sub disableaudio {
        my $self=shift;
        UI->{audiostate}=0;
        UI->activebuttons({left=>1, right=>1, 
                           stop=>0, reload=>1,
                           audio=>1
                         });        
}        

sub audiostate {
        my $self=shift;
        return UI->{audiostate}        
}        



# private 

sub _play_title {        
        my $current_doc=History->current;
        my $currdisplay=$current_doc->deck_handle->current;
        $current_doc->page_attr($currdisplay);        
}        


sub _config_title {
        my $current_doc=shift;
        my $title=$current_doc->title;
	my $header=UI->header;
	$header->configure(-text=>$title);
}

sub _buttons {
        my $type=shift;
#	($type=~/up/) && do {
#                my $current_doc=History->current;
#	        my $todisplay=$current_doc->deck_handle->back;
#                my $currdisplay=$current_doc->deck_handle->current;
##                print "currentdisplay: $currdisplay | to disp: $todisplay\n";
#		History->trace if $DEBUG;
#                $current_doc->deck_handle->trace if $DEBUG;		
#		On_display->set($todisplay);
#                $current_doc->page_attr($todisplay);
#		return
#		
#	};
#
#	($type=~/down/) && do {
#                my $current_doc=History->current;
#	        my $todisplay=$current_doc->deck_handle->forward;
#                History->trace if $DEBUG;
#                $current_doc->deck_handle->trace if $DEBUG;
#		On_display->set($todisplay);
#                $current_doc->page_attr($todisplay);                
#		return
#	
#	};

	($type=~/left/) && do {
                my $current_doc=History->current;
                my $currdisplay=$current_doc->deck_handle->current;
	        my $todisplay=$current_doc->deck_handle->back;
                
#               print "currentdisplay: $currdisplay | to disp: $todisplay\n";
                if($currdisplay eq $todisplay){
                        my $new_doc=History->back;
                        my $todisplay=$new_doc->deck_handle->current;
                        $new_doc->page_attr($todisplay);
                        On_display->set($todisplay);
                        _config_title($new_doc);
                        History->trace if $DEBUG;
                        $new_doc->deck_handle->trace if $DEBUG;
                }else{
                        History->trace if $DEBUG;
                        $current_doc->deck_handle->trace if $DEBUG;
                        On_display->set($todisplay);
                        $current_doc->page_attr($todisplay);
                }
		return
		
	};

	($type=~/right/) && do {
                my $current_doc=History->current;
                my $currdisplay=$current_doc->deck_handle->current;
	        my $todisplay=$current_doc->deck_handle->forward;
                
#               print "currentdisplay: $currdisplay | to disp: $todisplay\n";
                if($currdisplay eq $todisplay){
                        my $new_doc=History->forward;
                        my $todisplay=$new_doc->deck_handle->current;
                        History->trace  if $DEBUG;
                        $new_doc->deck_handle->trace  if $DEBUG;
                        $new_doc->page_attr($todisplay);
                        On_display->set($todisplay);
                        _config_title($new_doc);
                }else{
                        History->trace if $DEBUG;
                        $current_doc->deck_handle->trace if $DEBUG;
                        On_display->set($todisplay);
                        $current_doc->page_attr($todisplay);
                }        
		return
		
	};
	
	($type=~/stop/) && do {
                my $current_doc=History->current;
                $current_doc->stop;
		return
		
	};

	($type=~/reload/) && do {
                my $current_doc=History->current;
                my $newstate=State->new($current_doc->url);
                my $curr_page=$current_doc->deck_handle->page_no;
                $newstate->page_to_display([0,$curr_page]);
                History->back;
                History->add($newstate);
                Schedule->job($newstate);
                return
	};
        
        ($type=~/audio/) && do {                
                print "Audio!\n";
                UI->toggleaudio;
                return;
         };

}


sub activebuttons {
        my $self=shift;
        my $active_ref=shift;
        foreach $key (keys %$active_ref){
                my $state=$active_ref->{$key};
                $self->{button_state}->{$key}=$state;
#               print "$key => $state\n";                
                my $button = $self->{$key};
#               print "$key >>$button\n";
                if($state==2){
                        $button->configure(-state=>'active');
                }else{
                        $button->configure(-state=>$state?'normal':'disabled');                        
                }        
        }
}


sub activate_stop {
        UI->activebuttons({left=>0, right=>0, 
                           stop=>1, reload=>0,
                           audio=>0
                         });       
}        

sub deactivate_stop {
        UI->activebuttons({left=>1, right=>1, 
                           #up=>1,  down=>1, 
                           stop=>0, reload=>1,
                           audio=>1
                         });       
}        


sub get_button_state {
        my $self=shift;
        my $button=shift;
        return $self->{button_state}->{$button}
}        

sub set_button_state {
        my $self=shift; 
        my $button=shift;
        $self->{button_state}->{$button}=1;       
}

sub reset_button_state {
        my $self=shift; 
        my $button=shift;
        $self->{button_state}->{$button}=0;
}        


# debug 
sub debug {$DEBUG=1}
#

1;
