#!/usr/bin/perl

use Fcntl qw/:flock/;

$PATH="../../demos";
$BINPATH="../../demos/bin";
$MAX_SERVER=2;
#
%error_msg = (
        "500" => "Bad Protocol: Malformed request",
	"400" => "No such file: Missing File",
	"300" => "Service unavailable: Please try later",
	);
#
# modem call should go here 
#



# load the whoami file
open(W,"<who_am_i")||die $@;
map {chomp;$i_am{$_}=1} <W>;
close(W);

# get a socket and  listen 
socket(S,2,1,6)||die "no socket!";
setsockopt(S,SOL_SOCKET,SO_REUSEADDR,1);
bind(S,pack('S n x12',2,6789))||die;
listen(S,5)||die;

### parent code
$|=1;
for (1..$MAX_SERVER) {&fork_child();sleep(1)}
{my $pid=wait;if($pid!= -1){fork_child()}redo}

### end of parent code

sub fork_child {
	defined($pid=fork);
	if(!$pid){&child_program;exit}
}

sub child_program {
        open(F,">>LCK.applid");
	flock(F, LOCK_EX);
	my $mypid=$$;
	print stderr "$mypid has the lock\n";
	accept(N,S)||die;
	flock(F, LOCK_UN);
	close(F);
	select(N);$|=1;select(STDOUT);
	# get request.. read the first tag 
	my $partial_tag="";
        my $rin="";	my $rout;
	vec($rin,fileno(N),1) = 1;	
        $to=$method="";	$buff="";
        while(1){
                if(select($rout=$rin,undef, undef,3)){
	                sysread(N,$buff,1024)||exit;
		        $partial_tag .=$buff	                
	        }
	        _first_tag($partial_tag)&&last;
	}
	# parse the request 
        # $d: destination $v: relative url $p: port number

	($d,$v)=($to=~m%itp://(.*?)(/.*)%);
	my $p=6789;        if($d=~/:/){$d=$`;$p=$'};
	
	($d=~/^$/)&&do{error_msg("500");exit};	
	#  to local machine or remote ?
        if($i_am{$d}){
                if($v=~/\.\./){error_msg("500");return}
                my $pathd=$BINPATH.$v;
                my $paths=$PATH.$v;                
                if (-r $paths) {
                        print "$$>> $paths\t\t";
                        static_method($paths)
                }elsif(-x $pathd){
                        print "$$>> $pathd\t\t";                        
                        dynamic_method($pathd)                        
                }else{
                        error_msg("400");
                        return                        
                }
		print "\n";
		return;
		
        }else{
		print stderr " $mypid contacting remote machine $d\n";
		socket(SR,2,1,6)&&
		  connect(SR,pack'Sna4x8',2,$p,(gethostbyname $d)[4])||
		    do{
                        error_msg("300");
                        exit;
		    };
		select SR;$|=1;select STDOUT;
		syswrite(SR, $partial_tag, length($partial_tag));
		_select_loop(*SR, *N, *N, *SR);	
	}
        # send out the request
	close(N);	
}


sub static_method{
        open(G, shift)||do{error_msg("400");die "what is $paths?"};
        while(sysread(G, $buff,4096)){
                syswrite(N,$buff,length($buff));		
        }
}

sub dynamic_method{
        my $path=shift;
        pipe R0,W0;select W0; $|=1;
        pipe R1,W1;select W1; $|=1;
        select STDOUT;
        defined($chpid=fork)||exit;
        if (!$chpid) {# exec the process after duping 
                close(R1);close(W0);
                open(STDOUT,">&W1");
                open(STDIN, "<&R0");
                my ($cwd)=($path=~m%(.*)/%);
                chdir $cwd;
                exec $path or die "Hmmm!\n";
                exit;
        }
        close(R0);close(W1);
        if($rest){syswrite(W0, $rest, length($rest))}
        _select_loop(*R1, *N, *N, *W0)
}

#
# if you read R0 and write to W0;
# similarly read from R1 and write to W1;
#
# select_loop('R0 W0 R1 W1');
#

sub _select_loop {
	my ($fhr0,$fhw0,$fhr1,$fhw1)=@_;
        #print stderr "Numbers ",fileno($fhr0)," ",fileno($fhr1),"\n";
	my $rin  = '';	my $readsr, $readn;
	vec($rin,fileno($fhr0),1) = 1;
	vec($rin,fileno($fhr1),1) = 1;
	{
                my $eact=select(undef,undef,$eout=$rin,0);
                if (vec($eout,fileno($fhr0),1)) {
                        close($fhr0);
                        return undef;
                }
                if (vec($eout,fileno($fhr1),1)) {
                        close($fhr1);
                        return undef;
                }                
		my $nact=select($rout=$rin,undef,undef,undef);                
		($nact< 0) && return;
		($nact==0) && redo;
		if (vec($rout,fileno($fhr0),1)) {
			if (sysread($fhr0,$readsr,1024)>0) {
				syswrite($fhw0,$readsr,length($readsr));
                                #print stderr $readsr;
			} else {
				return;
			}
		}
		if (vec($rout,fileno($fhr1),1)) {
			if (sysread($fhr1,$readn,1024)>0) {
				syswrite($fhw1,$readn,length($readn));
                                #print stderr $readn;
			} else {
			        return;
			}
		}
		redo;
	}
}

sub _first_tag {
        my $input=shift;
        if($input =~ /^\s*<\s*iml (.*)>(.*)/s){
	        my $taginfo=$1;
                $rest=$2;
	        ($to)=($taginfo =~ /to\s*=\s*"(.*?)"/);
		($method)=($taginfo =~ /method\s*=\s*"(.*?)"/);
		return 1
	}
	return 0
}



sub error_msg {
        my $errorno=shift;
        my $msg=$error_msg{$errorno};
	my ($head, $rest)=split /:/, $msg;
	print stderr "$$ >>Error: $errorno $head\n\n";	
	print N "<iml status=\"$errorno\"><head><title>Error: $errorno $head</title></head>\n";
	print N "<card>$rest</card></iml>\n";
}
